/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { AnnotationLayer } from "./AnnotationLayer";
import { Series } from "./Series";
import { DependencyProperty } from "igniteui-react-core/ES5/DependencyProperty";
import { ItemTooltipLayerFrame } from "./ItemTooltipLayerFrame";
import { Type, Base, fromEnum, Point_$type, markType, DomWrapper_$type, runOn, String_$type, typeCast } from "igniteui-react-core/ES5/type";
import { Pool$1 } from "igniteui-react-core/ES5/Pool$1";
import { List$1 } from "igniteui-react-core/ES5/List$1";
import { ItemTooltipCollisionInfo } from "./ItemTooltipCollisionInfo";
import { Rect } from "igniteui-react-core/ES5/Rect";
import { DataContext } from "igniteui-react-core/ES5/DataContext";
import { Size } from "igniteui-react-core/ES5/Size";
import { DeviceUtils } from "igniteui-react-core/ES5/DeviceUtils";
import { PropertyMetadata } from "igniteui-react-core/ES5/PropertyMetadata";
import { isNaN_ } from "igniteui-react-core/ES5/number";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { PointerTooltip } from "./PointerTooltip";
var ItemToolTipLayer = /** @class */ (function (_super) {
    tslib_1.__extends(ItemToolTipLayer, _super);
    function ItemToolTipLayer() {
        var _this = _super.call(this) || this;
        var a = new ItemTooltipLayerFrame();
        var b = new ItemTooltipLayerFrame();
        var c = new ItemTooltipLayerFrame();
        var d = _this.fc / 1000;
        _this.lq = a;
        _this.lp = b;
        _this.lr = c;
        _this.ab = ItemToolTipLayer.$;
        return _this;
    }
    ItemToolTipLayer.prototype.bf = function () {
        return new ItemToolTipLayerView(this);
    };
    ItemToolTipLayer.prototype.ii = function (a) {
        _super.prototype.ii.call(this, a);
        this.mq = a;
    };
    ItemToolTipLayer.prototype.get_cm = function () {
        return true;
    };
    Object.defineProperty(ItemToolTipLayer.prototype, "cm", {
        get: function () {
            return this.get_cm();
        },
        enumerable: true,
        configurable: true
    });
    ItemToolTipLayer.prototype.io = function (a, b, c, d) {
        _super.prototype.io.call(this, a, b, c, d);
        switch (b) {
            case ItemToolTipLayer.$$p[1]:
                this.i1(true);
                break;
            case ItemToolTipLayer.$$p[2]:
                this.i1(true);
                break;
            case ItemToolTipLayer.$$p[0]:
                this.i1(true);
                break;
        }
    };
    ItemToolTipLayer.prototype.l7 = function (a, b) {
        if (this.mr == null || this.mr == a) {
            if (!this.aq.c) {
                this.i1(b);
            }
        }
    };
    ItemToolTipLayer.prototype.lu = function (a) {
        if (!_super.prototype.lu.call(this, a)) {
            return false;
        }
        var b = this.l2(a);
        if (!b.a) {
            return false;
        }
        return true;
    };
    ItemToolTipLayer.prototype.l9 = function (a, b) {
        _super.prototype.l9.call(this, a, b);
        var c = a;
        var d = this.mq.b0;
        var e = this.mu;
        var f = this.mt;
        c.o.clear();
        c.i.clear();
        c.n.clear();
        c.g.clear();
        c.f.clear();
        c.l.clear();
        c.j.clear();
        c.m.clear();
        c.k.clear();
        c.h.clear();
        if (isNaN_(this.mn.x) && isNaN_(this.mn.y)) {
            d.count = 0;
            return;
        }
        var g = 0;
        if (this.lu(this.mr)) {
            this.m0(this.mr, c, e, f, 0);
            g++;
        }
        else {
            try {
                for (var _a = tslib_1.__values(fromEnum(this.bs.series)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var h = _b.value;
                    if (this.lu(h)) {
                        this.m0(h, c, e, f, g);
                        g++;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_1) throw e_1.error; }
            }
            this.mz(c);
        }
        d.count = g;
        var e_1, _c;
    };
    ItemToolTipLayer.prototype.mz = function (a) {
        var b = new List$1(ItemTooltipCollisionInfo.$, 0);
        for (var c = 0; c < a.f.count; c++) {
            var d = new ItemTooltipCollisionInfo();
            d.d = c;
            d.e = { $type: Point_$type, x: a.f._inner[c], y: a.g._inner[c] };
            d.c = a.m._inner[c];
            d.a = a.k._inner[c];
            d.b = a.o._inner[c];
            if (isNaN_(d.e.x) || isNaN_(d.e.y)) {
                continue;
            }
            b.add(d);
        }
        b.aa(function (e, f) {
            if (e.e.y < f.e.y) {
                return -1;
            }
            if (e.e.y > f.e.y) {
                return 1;
            }
            if (e.b < f.b) {
                return -1;
            }
            if (e.b > f.b) {
                return 1;
            }
            return 0;
        });
        var e = this.ms(b);
        if (!e) {
            return;
        }
        for (var f = 0; f < b.count - 1; f++) {
            var g = b._inner[f];
            var h = b._inner[f + 1];
            var i = new Rect(0, g.e.x, g.e.y, g.c, g.a);
            var j = new Rect(0, h.e.x, h.e.y, h.c, h.a);
            if (i.intersectsWith(j) || i.top > j.bottom) {
                h.e = { $type: Point_$type, x: h.e.x, y: i.bottom + 1 };
            }
        }
        if (b._inner[b.count - 1].e.y + b._inner[b.count - 1].a > this.bi.bp.height) {
            b._inner[b.count - 1].e = { $type: Point_$type, x: b._inner[b.count - 1].e.x, y: b._inner[b.count - 1].e.y - ((b._inner[b.count - 1].e.y + b._inner[b.count - 1].a) - this.bi.bp.height) };
        }
        for (var k = b.count - 1; k >= 1; k--) {
            var l = b._inner[k];
            var m = b._inner[k - 1];
            var n = new Rect(0, l.e.x, l.e.y, l.c, l.a);
            var o = new Rect(0, m.e.x, m.e.y, m.c, m.a);
            if (n.intersectsWith(o) || n.top < o.bottom) {
                m.e = { $type: Point_$type, x: m.e.x, y: n.top - (o.height + 1) };
            }
        }
        for (var p = 0; p < b.count; p++) {
            var q = b._inner[p].d;
            var r = b._inner[p];
            a.f._inner[q] = r.e.x;
            a.g._inner[q] = r.e.y;
        }
    };
    ItemToolTipLayer.prototype.ms = function (a) {
        if (a.count <= 1) {
            return false;
        }
        var b = this.bi.bp;
        for (var c = 0; c < a.count - 1; c++) {
            var d = a._inner[c];
            var e = a._inner[c + 1];
            var f = new Rect(0, d.e.x, d.e.y, d.c, d.a);
            var g = new Rect(0, e.e.x, e.e.y, e.c, e.a);
            if (f.intersectsWith(g)) {
                return true;
            }
        }
        return false;
    };
    ItemToolTipLayer.prototype.m0 = function (a, b, c, d, e) {
        var f = this.l2(a);
        if (!f.a) {
            return;
        }
        var g = a.k9(f.b, c, d);
        var h = this.mq.b0;
        var i = this.mv(a);
        var j = this.mn;
        if (!c) {
            j = this.lc(g);
        }
        var k = a.fj(j);
        var l = h.item(e);
        var m = this.bi.bp;
        var n = null;
        if (a.cn && k != null) {
            n = a.as(k);
        }
        else {
            n = new DataContext();
            n.item = k;
            n.series = a;
        }
        if (!this.mq.b1(a, l, i, n)) {
            return;
        }
        var o = this.mq.ca(l, i, n);
        b.i.add1(l);
        b.j.add1(n);
        b.l.add1(i);
        var p = g.x;
        var q = g.x;
        q = Math.max(q, m.left);
        q = Math.min(q, m.right);
        b.n.add(q);
        var r = g.y;
        r = Math.max(r, m.top);
        r = Math.min(r, m.bottom);
        b.o.add(r);
        var s = DeviceUtils.g(10);
        var t = g.x + s;
        if (t + o.width > m.right) {
            t = (p - o.width) - s;
        }
        if (t < m.left) {
            t = m.left;
        }
        b.f.add(t);
        var u = (g.y - o.height) - s;
        if (u + o.height > m.bottom) {
            u = (m.bottom - o.height) - s;
        }
        if (u < m.top) {
            u = m.top;
        }
        b.g.add(u);
        b.m.add(o.width);
        b.k.add(o.height);
        var v = this.kr;
        if (v == null) {
            v = this.kt;
        }
        if (v == null) {
            v = a.kr;
        }
        b.h.add(v);
    };
    ItemToolTipLayer.prototype.mv = function (a) {
        return a.toolTip;
    };
    ItemToolTipLayer.prototype.mc = function (a, b) {
        _super.prototype.mc.call(this, a, b);
        var c = a;
        var d = c.o.count;
        var e = b.bp.left;
        var f = b.bp.right;
        var g = b.bp.top;
        var h = b.bp.bottom;
        for (var i = 0; i < d; i++) {
            if (isNaN_(c.n._inner[i]) || isNaN_(c.o._inner[i]) || isNaN_(c.f._inner[i]) || isNaN_(c.g._inner[i]) || c.l._inner[i] == null || c.j._inner[i] == null) {
                this.mq.b8(c.i._inner[i]);
                continue;
            }
            var j = c.f._inner[i];
            var k = c.g._inner[i];
            var l = c.m._inner[i];
            var m = c.k._inner[i];
            var n = false;
            if (j < e && Math.abs(j - e) > 1) {
                n = true;
            }
            if (k < g && Math.abs(k - g) > 1) {
                n = true;
            }
            if ((j + l) > f && Math.abs((j + l) - f) > 1) {
                n = true;
            }
            if ((k + m) > h && Math.abs((k + m) - h) > 1) {
                n = true;
            }
            if (n) {
                this.mq.b8(c.i._inner[i]);
                continue;
            }
            var o = c.i._inner[i];
            var p = Math.min(c.f._inner[i], c.n._inner[i]);
            var q = Math.min(c.g._inner[i], c.o._inner[i]);
            var r = c.n._inner[i] - c.f._inner[i];
            var s = c.o._inner[i] - c.g._inner[i];
            this.mq.b9(o, p, q, r, s);
        }
    };
    ItemToolTipLayer.prototype.c5 = function () {
        return true;
    };
    ItemToolTipLayer.$t = markType(ItemToolTipLayer, 'ItemToolTipLayer', AnnotationLayer.$);
    return ItemToolTipLayer;
}(AnnotationLayer));
export { ItemToolTipLayer };
Type.dep(DependencyProperty, PropertyMetadata, ItemToolTipLayer, 'raisePropertyChanged', ['SkipUnknownValues:mt:m1', [0, true], 'TargetSeries:mr:m2', [Series.$, null], 'UseInterpolation:mu:m3', [0, false]]);
var ItemToolTipLayerView = /** @class */ (function (_super) {
    tslib_1.__extends(ItemToolTipLayerView, _super);
    function ItemToolTipLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.bz = null;
        _this.b0 = null;
        _this.b2 = null;
        _this._htmlTest = null;
        _this.bz = a;
        _this.b2 = new List$1(PointerTooltip.$, 0);
        return _this;
    }
    ItemToolTipLayerView.prototype.ap = function () {
        var _this = this;
        _super.prototype.ap.call(this);
        this.b0 = ((function () {
            var $ret = new Pool$1(Base.$);
            $ret.create = runOn(_this, _this.b3);
            $ret.activate = runOn(_this, _this.b5);
            $ret.disactivate = runOn(_this, _this.b7);
            $ret.destroy = runOn(_this, _this.b6);
            return $ret;
        })());
        this.htmlTest = /^[^<]*(<[\w\W]+>)[^>]*$/;
    };
    ItemToolTipLayerView.prototype.ag = function () {
        _super.prototype.ag.call(this);
        for (var a = 0; a < this.b0.a.count; a++) {
            this.b0.a._inner[a].bo();
        }
        for (var b = 0; b < this.b0.b.count; b++) {
            this.b0.b._inner[b].bo();
        }
        this.b0.clear();
    };
    ItemToolTipLayerView.prototype.b3 = function () {
        var a = new PointerTooltip();
        a.bs(this.e.ey);
        a._visibility = 1;
        a.ao = this.e.bs.bk.j;
        this.b2.add(a);
        return a;
    };
    ItemToolTipLayerView.prototype.b5 = function (a) {
        var b = a;
    };
    ItemToolTipLayerView.prototype.b7 = function (a) {
        var b = a;
        b._visibility = 1;
    };
    ItemToolTipLayerView.prototype.b6 = function (a) {
        var b = a;
        b.bv();
        b.content = null;
        this.b2.remove1(a);
    };
    Object.defineProperty(ItemToolTipLayerView.prototype, "htmlTest", {
        get: function () {
            return this._htmlTest;
        },
        set: function (a) {
            this._htmlTest = a;
        },
        enumerable: true,
        configurable: true
    });
    ItemToolTipLayerView.prototype.b1 = function (a, b, c, d) {
        var e = b;
        if (a.fq == "default") {
            a.fq = a.bi.getDefaultTooltipTemplate();
        }
        var template_ = a.fq;
        var context_ = d;
        var f = false;
        if (!f) {
            return false;
        }
        if (a.ew == null) {
            return false;
        }
        var args_ = a.ew(d);
        var g = this.e.bs.bk.i.af.expandTemplate(template_, args_);
        e.content = g;
        return true;
    };
    ItemToolTipLayerView.prototype.ca = function (a, b, c) {
        var d = a;
        var e = d.content;
        var f = new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY);
        d.ct = 1;
        var g = d.cs(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
        d.ct = 0;
        return g;
    };
    ItemToolTipLayerView.prototype.b9 = function (a, b, c, d, e) {
        var f = null;
        if (this.e.bs != null) {
            f = this.e.bs.bk.i.i();
        }
        var g = a;
        g.ap = f;
        var h = g.content;
        g.cn = { $type: Point_$type, x: d, y: e };
        g._visibility = 0;
        g.n = b;
        g.o = c;
    };
    ItemToolTipLayerView.prototype.b8 = function (a) {
        if (a != null) {
            var b = a;
            b._visibility = 1;
        }
    };
    ItemToolTipLayerView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (b) {
            return;
        }
        var c = 0;
        var d = 0;
        var e = this.e.bs;
        if (e != null) {
            var f = e.bk.i.b5();
            c += f.x;
            d += f.y;
        }
        for (var g = 0; g < this.b2.count; g++) {
            this.b2._inner[g].bu(this.b2._inner[g].n + c, this.b2._inner[g].o + d);
        }
    };
    ItemToolTipLayerView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        try {
            for (var _a = tslib_1.__values(fromEnum(this.b0.a)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var tooltip_ = _b.value;
                if (tooltip_._visibility != 0) {
                    continue;
                }
                var b = tooltip_;
                var c = b.a3();
                var d = b.n;
                var e = b.o;
                var f = new List$1(String_$type, 0);
                var g = typeCast(DomWrapper_$type, b.content);
                if (g != null) {
                    var h = g.getText();
                    f.add(h);
                }
                this.e.a2.addPointerTooltipData(a, c, d, e, f);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_2) throw e_2.error; }
        }
        var e_2, _c;
    };
    ItemToolTipLayerView.$t = markType(ItemToolTipLayerView, 'ItemToolTipLayerView', AnnotationLayerView.$);
    return ItemToolTipLayerView;
}(AnnotationLayerView));
export { ItemToolTipLayerView };
/*<BeginStatics Name="Infragistics.Controls.Charts.ItemToolTipLayer" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.ItemToolTipLayer" />*/
